//ProjectBucket - SOLUTION //    

/**
 *This class solves the "Magician Heplper's " problem, as specified in Ex
 *@author OOP team.
 */
public class Magician {
	
	public static void main(String args[]) {
		
		final int SIZE_OF_ROOM = 20;
     	//request all the relvant data from user,
     	//and check that it is leagal
     	int waterInRoom, capacity1, capacity2;
     	//request amount of water in room:
     	waterInRoom = InputRequestor.requestInt("Please enter the initial amount of " +
			"water in room in liters. The amount should be between 0 and " +
			SIZE_OF_ROOM);
     	//make sure this amount is betwwen 0...size of room:
     	while(waterInRoom > SIZE_OF_ROOM|| waterInRoom<0){
      		waterInRoom = InputRequestor.requestInt("The amount of water in room must " +
				"be between 0 and " +SIZE_OF_ROOM +
				". Please enter the amount again");
     	}	
     	//request bucket1's capcity:
     	capacity1 = InputRequestor.requestInt("Please enter capacity of bucket1 in liters"+
			". The capcity should be between 1.." + SIZE_OF_ROOM);
     	//make sure 0<capacity1<sizeOfRoom:
     	while(capacity1>SIZE_OF_ROOM || capacity1<=0){
       		capacity1 = InputRequestor.requestInt("bucket1's capacity must be between 1.." +
				SIZE_OF_ROOM + ". Please enter capcity again");
     	}
     	//request bucket2's capcity:
     	capacity2 = InputRequestor.requestInt("Please enter capacity of bucket2 in liters"+
			". The capacity should be between 1.." + capacity1);
     	//make sure 0<capacity2<capcity1:
     	while(capacity2>capacity1 || capacity2<=0){
        	capacity2 = InputRequestor.requestInt("bucket2's capacity must be between 1.. " +
				capacity1 + ". Please enter capcity again");
     	}	

     	//construct three buckets according to data:
     	Bucket room = new Bucket(SIZE_OF_ROOM ,"room");
     	Bucket bucket1 = new Bucket (capacity1,"bucket1");
     	Bucket bucket2 = new Bucket (capacity2,"bucket2");
     	room.fill(waterInRoom);
     	//now solve the problem:
     	while(!room.isEmpty()){
       		room.pourInto(bucket1);
       		while(!bucket1.isEmpty()){    
        		bucket1.pourInto(bucket2);
          		bucket2.empty();
       		}	
       	}
	}//end of main
}//end of class

